@echo off
if "%2"=="" goto expl

echo Converting bin2dec(nnnnnnnn) to decimal numbers..
bin\bin2.exe %1.c %1.b2d
if errorlevel 1 goto errors
echo Auto-including C functions..
bin\gain inc\stdlib.aic %1.b2d %1.pre
if errorlevel 1 goto errors
echo Preprocessing..
bin\cpp.exe -DHITECH_C -Dz80 -I.\ %1.pre %1.000
if errorlevel 1 goto errors
echo Compiling to intermediate code..
bin\p1.exe -QPi,port -QQ,fast -QM,nmi -S %1.000 %1.001 %1.002
if errorlevel 1 goto errors
echo Compiling to assembler..
lh bin\cgen.exe %1.001 %1.000
if errorlevel 1 goto errors
echo Optimizing..
bin\optim.exe %1.000 %1.as
if errorlevel 1 goto errors

if exist %1.000 del %1.000 >nul
if exist %1.001 del %1.001 >nul
if exist %1.002 del %1.002 >nul

echo Autoincluding ASM routines..
bin\gain inc\extras.aih %1.as %1.as0
if errorlevel 1 goto errors
echo Converting..
bin\convert %1.as0 %1.asm %3 %4 %5 %6 %7 %8 %9
if errorlevel 1 goto errors
del convert.$?? >nul

if exist objlist.dat del objlist.dat >nul
bin\srcwiz %1.asm
bin\tasm -80 -g3 -r12 -ll %1.asm
if errorlevel 1 goto errors
if exist objlist.dat bin\srcwiz %1.obj -r
move %1.lst %2.lst >nul
move %1.obj %2.obj >nul
bin\string85 %2.obj
move %2.obj %1.obj >nul
move %2.lst %1.lst >nul
move %2.85s %1.85s >nul
if exist %1.bak del %1.bak >nul
if exist %1.lst del %1.lst >nul
if exist %1.obj del %1.obj >nul

call reloc$$$.bat
del reloc$$$.bat >nul
if exist objlist.dat del objlist.dat >nul
goto end

:expl
echo A batch file to make compiling C-programs easier. 
echo (doesn't delete all temporary files; handy for debugging)
echo.
echo Usage : ticd {c-prog-name} {string-name} [prog-title-text]
echo.
echo For example, to compile a c-program foobar.c to a string named "Quux"
echo with "Ultimate HyperGame Version 1.0" as program title:
echo.
echo   ticd foobar Quux Ultimate HyperGame Version 1.0
echo.
goto end

:errors
echo You can't do *that*!
:end
